//+------------------------------------------------------------------+
//|                                                     smoothed rsi |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers  1
#property indicator_color1   DeepSkyBlue
#property indicator_width1   3
#property indicator_minimum  0
#property indicator_maximum  100
#property indicator_level1   20.0
#property indicator_level2   30.0
#property indicator_level3   40.0
#property indicator_level4   50.0
#property indicator_level5   60.0
#property indicator_level6   70.0
#property indicator_level7   80.0
#property indicator_levelcolor Magenta


//
//
//
//
//

extern int    Length          = 14;
extern int    Price           = PRICE_CLOSE;
extern bool   Smooth          = true;
extern bool   Show_10_90      = TRUE;
extern int    IndicatorWindow = 1;
extern color  extralevelcolor = Magenta;


//
//
//
//
//

double rsi[];
double prc[];



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
      IndicatorBuffers(2);
      SetIndexBuffer(0,rsi);
      SetIndexBuffer(1,prc);
   
         Length = MathMax(Length ,1);
         
         

   //
   //
   //
   //
   //

         
         
         string PriceType;
         switch(Price)
         {
            case PRICE_CLOSE:    PriceType = "Close";    break;  // 0
            case PRICE_OPEN:     PriceType = "Open";     break;  // 1
            case PRICE_HIGH:     PriceType = "High";     break;  // 2
            case PRICE_LOW:      PriceType = "Low";      break;  // 3
            case PRICE_MEDIAN:   PriceType = "Median";   break;  // 4
            case PRICE_TYPICAL:  PriceType = "Typical";  break;  // 5
            case PRICE_WEIGHTED: PriceType = "Weighted"; break;  // 6
         } 
       if (Show_10_90) 
        {
        ObjectCreate("90_LINE", OBJ_HLINE, IndicatorWindow, 0, 90);
        ObjectSet("90_LINE", OBJPROP_COLOR, extralevelcolor);
        ObjectSet("90_LINE", OBJPROP_WIDTH, 1);
        ObjectSet("90_LINE", OBJPROP_STYLE, STYLE_DOT);
        ObjectCreate("10_LINE", OBJ_HLINE, IndicatorWindow, 0, 10);
        ObjectSet("10_LINE", OBJPROP_COLOR, extralevelcolor);
        ObjectSet("10_LINE", OBJPROP_WIDTH, 1);
        ObjectSet("10_LINE", OBJPROP_STYLE, STYLE_DOT);
        }
         
      

  
      string addName = "";
         if (Smooth) addName = "smoothed ";
   IndicatorShortName(" RSI "+addName+"("+Length+","+PriceType+")");
   return(0);
}
int deinit()  
{
  ObjectDelete("10_LINE");
  ObjectDelete("90_LINE");
  
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k,n,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

 
      for(i=limit; i >= 0; i--)
      {
         if (Smooth)
               prc[i] = (iMA(NULL,0,1,0,MODE_SMA,Price,i)+2.0*iMA(NULL,0,1,0,MODE_SMA,Price,i+1)+iMA(NULL,0,1,0,MODE_SMA,Price,i+2))/4.0;
         else  prc[i] =  iMA(NULL,0,1,0,MODE_SMA,Price,i);
         if (i>=Bars-Length) continue;
      
         double cu = 0;
         double cd = 0;
         for (k=0; k<Length; k++)
            {
               double diff = prc[i+k]-prc[i+k+1];
                  if (diff > 0)
                        cu += diff;
                  else  cd -= diff;
            }
         if ((cu+cd)!=0)
               rsi[i] = 50.0*((cu-cd)/(cu+cd)+1.0);
         else  rsi[i] = 0;

         //
         //
         //
         //
         //
         
           
      }
 
      return(0);
   }   
   
   